Index: /trunk/lib/FlairVisionFilter/src/ImgThreshold.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/ImgThreshold.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/ImgThreshold.cpp	(revision 122)
@@ -0,0 +1,74 @@
+//  created:    2015/10/07
+//  filename:   ImgThreshold.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    ImgThreshold
+//
+//
+/*********************************************************************/
+
+#include "ImgThreshold.h"
+#include <cvimage.h>
+#include <Layout.h>
+#include <GroupBox.h>
+#include <SpinBox.h>
+#include <typeinfo>
+
+using std::string;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair { namespace filter {
+
+ImgThreshold::ImgThreshold(const IODevice* parent,const LayoutPosition* position,string name) : IODevice(parent,name),output(0) {
+    GroupBox* reglages_groupbox=new GroupBox(position,name);
+    threshold=new SpinBox(reglages_groupbox->NewRow(),"threshold:",0,255,1,127);
+
+    Printf("todo: pouvoir reutiliser la meme image en sortie\n");
+    try{
+        cvimage::Type const &imageType=dynamic_cast<cvimage::Type const &>(parent->GetOutputDataType());
+        if(imageType.GetFormat()==cvimage::Type::Format::GRAY) {
+            output=new cvimage(this,imageType.GetWidth(),imageType.GetHeight(),imageType.GetFormat(),"threshold");
+        } else {
+            Err("input image is not grey\n");
+        }
+    } catch(std::bad_cast& bc) {
+        Err("io type mismatch\n");
+    }
+}
+
+ImgThreshold::~ImgThreshold(void) {
+}
+
+cvimage* ImgThreshold::Output(void) {
+    return output;
+}
+
+void ImgThreshold::UpdateFrom(const io_data *data) {
+    cvimage *cvImage=(cvimage*)data;
+    IplImage *gimg=cvImage->img;
+/*
+    data->GetMutex();
+    output->GetMutex();
+    dspThreshold(gimg, output->img, threshold->Value(), 255, CV_THRESH_BINARY);
+    output->ReleaseMutex();
+    data->ReleaseMutex();
+*/
+    output->SetDataTime(data->DataTime());
+    ProcessUpdate(output);
+}
+
+DataType const &ImgThreshold::GetOutputDataType() const {
+    if(output!=NULL) {
+        return output->GetDataType();
+    } else {
+        return dummyType;
+    }
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/ImgThreshold.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/ImgThreshold.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/ImgThreshold.h	(revision 122)
@@ -0,0 +1,71 @@
+/*!
+ * \file ImgThreshold.h
+ * \brief ImgThreshold algorithm
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2015/10/07
+ * \version 4.0
+ */
+
+
+#ifndef IMGTHRESHOLD_H
+#define IMGTHRESHOLD_H
+
+#include <IODevice.h>
+#include <cv.h>
+
+namespace flair {
+    namespace core {
+        class cvimage;
+    }
+    namespace gui {
+        class LayoutPosition;
+        class SpinBox;
+    }
+}
+
+namespace flair { namespace filter {
+    /*! \class ImgThreshold
+    *
+    * \brief ImgThreshold algorithm
+    *
+    * ImgThreshold is done using the DSP of the DM3730.
+    */
+    class ImgThreshold : public core::IODevice {
+        public:
+            /*!
+            * \brief Constructor
+            *
+            * Construct an OpticalFlow filter at given position. \n
+            * After calling this function, position will be deleted as it is no longer usefull. \n
+            *
+            * \param parent parent
+            * \param position position
+            * \param name name
+            */
+            ImgThreshold(const core::IODevice* parent,const gui::LayoutPosition* position,std::string name);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~ImgThreshold();
+
+            /*!
+            * \brief Output image
+            *
+            * Output matrix is of the same size as the input image. \n
+            *
+            * \return the output image
+            */
+            core::cvimage* Output(void);
+
+            core::DataType const &GetOutputDataType() const;
+
+        private:
+            void UpdateFrom(const core::io_data *data);
+            core::cvimage *output;
+            gui::SpinBox *threshold;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // IMGTHRESHOLD_H
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlow.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlow.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlow.cpp	(revision 122)
@@ -0,0 +1,167 @@
+//  created:    2012/04/12
+//  filename:   OpticalFlow.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    calcul flux optique lk
+//
+//
+/*********************************************************************/
+
+#include "OpticalFlow.h"
+#include "OpticalFlowData.h"
+#include <cvimage.h>
+#include <Layout.h>
+#include <GroupBox.h>
+#include <SpinBox.h>
+//#include <algorithm>
+#include <OneAxisRotation.h>
+#include <Vector3D.h>
+#include <typeinfo>
+
+#define LEVEL_PYR 2
+
+using std::string;
+using std::swap;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair
+{
+namespace filter
+{
+
+OpticalFlow::OpticalFlow(const IODevice* parent,const LayoutPosition* position,string name) : IODevice(parent,name)
+{
+    Printf("optical flow: voir pour faire du multiple output\n");//pour pts A et B, found et error
+
+    try{
+        cvimage::Type const &imageType=dynamic_cast<cvimage::Type const &>(parent->GetOutputDataType());
+        pyr=cvCreateImage(cvSize(imageType.GetWidth(),imageType.GetHeight()),IPL_DEPTH_8U,1);
+        pyr_old=cvCreateImage(cvSize(imageType.GetWidth(),imageType.GetHeight()),IPL_DEPTH_8U,1);
+
+    } catch(std::bad_cast& bc) {
+        Err("io type mismatch\n");
+        pyr=NULL;
+        pyr_old=NULL;
+    }
+
+    is_init=false;
+
+    GroupBox* reglages_groupbox=new GroupBox(position,name);
+        rotation=new OneAxisRotation(reglages_groupbox->NewRow(),"post rotation");
+        max_features=new SpinBox(reglages_groupbox->NewRow(),"max features:",1,65535,1,1);
+
+    output=new OpticalFlowData(parent,max_features->Value());
+
+    pointsA=(CvPoint *)cvAlloc(max_features->Value()*sizeof(CvPoint));
+    pointsB=(CvPoint *)cvAlloc(max_features->Value()*sizeof(CvPoint));
+
+    found_feature=(char *)cvAlloc(max_features->Value()*sizeof(char));
+    feature_error=(unsigned int *)cvAlloc(max_features->Value()*sizeof(unsigned int));
+}
+
+OpticalFlow::~OpticalFlow(void)
+{
+    cvReleaseImage(&pyr);
+    cvReleaseImage(&pyr_old);
+    cvFree(&pointsA);
+    cvFree(&pointsB);
+    cvFree(&found_feature);
+    cvFree(&feature_error);
+}
+
+void OpticalFlow::UpdateFrom(const io_data *data)
+{
+    IplImage *gimg=((cvimage*)data)->img;
+    IplImage *gimg_old=((cvimage*)data->Prev(1))->img;
+
+    unsigned int count;
+    CvSize window = cvSize(3,3);
+    CvTermCriteria termination_criteria = cvTermCriteria( CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 20, .3 );
+    unsigned int i;
+
+    if(max_features->ValueChanged()==true)
+    {
+        cvFree(&pointsA);
+        cvFree(&pointsB);
+        cvFree(&found_feature);
+        cvFree(&feature_error);
+        pointsA=(CvPoint *)cvAlloc(max_features->Value()*sizeof(CvPoint));
+        pointsB=(CvPoint *)cvAlloc(max_features->Value()*sizeof(CvPoint));
+        found_feature=(char *)cvAlloc(max_features->Value()*sizeof(char));
+        feature_error=(unsigned int *)cvAlloc(max_features->Value()*sizeof(unsigned int));
+
+        output->Resize(max_features->Value());
+    }
+/*
+    if(is_init==false)
+    {
+        data->GetMutex();
+        //init image old
+        dspPyrDown(gimg,pyr_old,LEVEL_PYR);
+        data->ReleaseMutex();
+        is_init=true;
+        printf("ajouter mise a 0 des points\n");
+        return;
+    }
+
+    data->GetMutex();
+    data->Prev(1)->GetMutex();
+
+    //select good features
+    count=max_features->Value();
+    dspGoodFeaturesToTrack(gimg_old,pointsA,&count,0.08,5);
+    //pyramide
+    dspPyrDown(gimg,pyr,LEVEL_PYR);
+    //lk
+    dspCalcOpticalFlowPyrLK(gimg_old,gimg,pyr_old,pyr,pointsA,pointsB,count,window,LEVEL_PYR,found_feature,feature_error,termination_criteria,0) ;
+
+    data->Prev(1)->ReleaseMutex();
+    data->ReleaseMutex();
+*/
+    //apply rotation
+    for(i=0;i<count;i++)
+    {
+        Vector3D tmp;
+        tmp.x=pointsA[i].x;
+        tmp.y=pointsA[i].y;
+        tmp.z=0;
+        rotation->ComputeRotation(tmp);
+        pointsA[i].x=tmp.x;
+        pointsA[i].y=tmp.y;
+
+        tmp.x=pointsB[i].x;
+        tmp.y=pointsB[i].y;
+        tmp.z=0;
+        rotation->ComputeRotation(tmp);
+        pointsB[i].x=tmp.x;
+        pointsB[i].y=tmp.y;
+    }
+
+    output->GetMutex();
+    CvPoint2D32f* pointsBf= output->PointsB();
+    for(i=0;i<count;i++)
+    {
+        pointsBf[i].x=pointsA[i].x+((float)pointsB[i].x)/256;
+        pointsBf[i].y=pointsA[i].y+((float)pointsB[i].y)/256;
+    }
+    output->ReleaseMutex();
+
+    output->SetPointsA(pointsA);
+    output->SetFoundFeature(found_feature);
+    output->SetFeatureError(feature_error);
+    output->SetNbFeatures(count);
+
+    //rotation
+    swap(pyr,pyr_old);
+
+    output->SetDataTime(data->DataTime());
+    ProcessUpdate(output);
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlow.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlow.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlow.h	(revision 122)
@@ -0,0 +1,82 @@
+/*!
+ * \file OpticalFlow.h
+ * \brief Lucas and Kanade optical flow algorithm
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2012/04/12
+ * \version 4.0
+ */
+
+
+#ifndef OPTICALFLOW_H
+#define OPTICALFLOW_H
+
+#include <IODevice.h>
+#include <cv.h>
+
+namespace flair
+{
+    namespace core
+    {
+        class cvimage;
+        class OneAxisRotation;
+    }
+    namespace gui
+    {
+        class LayoutPosition;
+        class SpinBox;
+    }
+    namespace filter
+    {
+        class OpticalFlowData;
+    }
+}
+
+namespace flair
+{
+namespace filter
+{
+    /*! \class OpticalFlow
+    *
+    * \brief Lucas and Kanade optical flow algorithm
+    *
+    * Optical flow is done using the DSP of the DM3730.
+    */
+    class OpticalFlow : public core::IODevice
+    {
+
+        public:
+            /*!
+            * \brief Constructor
+            *
+            * Construct an OpticalFlow filter at given position. \n
+            * After calling this function, position will be deleted as it is no longer usefull. \n
+            *
+            * \param parent parent
+            * \param position position
+            * \param name name
+            */
+            OpticalFlow(const core::IODevice* parent,const gui::LayoutPosition* position,std::string name);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~OpticalFlow();
+
+        private:
+            void UpdateFrom(const core::io_data *data);
+            OpticalFlowData *output;
+            gui::SpinBox *max_features;
+            core::OneAxisRotation* rotation;
+
+            CvPoint* pointsA;
+            CvPoint* pointsB;
+            char *found_feature;
+            unsigned int *feature_error;
+            IplImage *pyr,*pyr_old;
+
+            bool is_init;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // OPTICALFLOW_H
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowData.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowData.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowData.cpp	(revision 122)
@@ -0,0 +1,156 @@
+//  created:    2012/04/12
+//  filename:   OpticalFlowData.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    classe pour les données du flux optique
+//
+/*********************************************************************/
+
+#include "OpticalFlowData.h"
+
+using std::string;
+
+namespace flair
+{
+namespace filter
+{
+
+OpticalFlowData::OpticalFlowData(const Object* parent,uint32_t max_features,string name,uint32_t n): io_data(parent,name,n)
+{
+    this->max_features=max_features;
+    nb_features=0;
+
+    pointsA=(CvPoint *)cvAlloc(max_features*sizeof(CvPoint));
+    pointsB=(CvPoint2D32f *)cvAlloc(max_features*sizeof(CvPoint2D32f));
+
+    found_features=(char *)cvAlloc(max_features*sizeof(char));
+    features_error=(uint32_t*)cvAlloc(max_features*sizeof(uint32_t));
+}
+
+OpticalFlowData::~OpticalFlowData()
+{
+    cvFree(&pointsA);
+    cvFree(&pointsB);
+
+    cvFree(&found_features);
+    cvFree(&features_error);
+}
+
+CvPoint* OpticalFlowData::PointsA(void) const
+{
+    return pointsA;
+}
+
+CvPoint2D32f* OpticalFlowData::PointsB(void) const
+{
+    return pointsB;
+}
+
+char *OpticalFlowData::FoundFeature(void) const
+{
+    return found_features;
+}
+
+uint32_t *OpticalFlowData::FeatureError(void) const
+{
+    return features_error;
+}
+
+// value is new max_features value
+void OpticalFlowData::Resize(uint32_t value) {
+    CvPoint *new_pointsA;
+    CvPoint2D32f *new_pointsB;
+    char *new_found_features;
+    uint32_t *new_features_error;
+
+    new_pointsA=(CvPoint *)cvAlloc(value*sizeof(CvPoint));
+    new_pointsB=(CvPoint2D32f *)cvAlloc(value*sizeof(CvPoint2D32f));
+    new_found_features=(char *)cvAlloc(value*sizeof(char));
+    new_features_error=(uint32_t *)cvAlloc(value*sizeof(uint32_t));
+
+    GetMutex();
+    if(value>max_features)
+    {
+        memcpy(new_pointsA,pointsA,max_features*sizeof(CvPoint));
+        memcpy(new_pointsB,pointsB,max_features*sizeof(CvPoint2D32f));
+        memcpy(new_found_features,found_features,max_features*sizeof(char));
+        memcpy(new_features_error,features_error,max_features*sizeof(uint32_t));
+    }
+    else
+    {
+        memcpy(new_pointsA,pointsA,value*sizeof(CvPoint));
+        memcpy(new_pointsB,pointsB,value*sizeof(CvPoint2D32f));
+        memcpy(new_found_features,found_features,value*sizeof(char));
+        memcpy(new_features_error,features_error,value*sizeof(uint32_t));
+        if(nb_features>value) nb_features=value; //si nb_features est le nombre de point qui ont effectivement une correspondande, ça me parait louche. Sauf si les points sont classés et que ceux qui ont une correpondance sont toujours au début
+    }
+    max_features=value;
+    ReleaseMutex();
+
+    cvFree(&pointsA);
+    cvFree(&pointsB);
+    cvFree(&found_features);
+    cvFree(&features_error);
+
+    pointsA=new_pointsA;
+    pointsB=new_pointsB;
+    found_features=new_found_features;
+    features_error=new_features_error;
+}
+
+void OpticalFlowData::CopyDatas(char* dst) const
+{
+    Warn("non implementé\n");
+}
+
+void OpticalFlowData::SetPointsA(const CvPoint* points)
+{
+    GetMutex();
+    memcpy(pointsA,points,max_features*sizeof(CvPoint));
+    ReleaseMutex();
+}
+
+void OpticalFlowData::SetPointsB(const CvPoint2D32f* points)
+{
+    GetMutex();
+    memcpy(pointsB,points,max_features*sizeof(CvPoint2D32f));
+    ReleaseMutex();
+}
+
+void OpticalFlowData::SetFoundFeature(const char *found_features)
+{
+    GetMutex();
+    memcpy(this->found_features,found_features,max_features*sizeof(char));
+    ReleaseMutex();
+}
+
+void OpticalFlowData::SetFeatureError(const uint32_t *features_error)
+{
+    GetMutex();
+    memcpy(this->features_error,features_error,max_features*sizeof(uint32_t));
+    ReleaseMutex();
+}
+
+uint32_t OpticalFlowData::MaxFeatures(void) const
+{
+    return max_features;
+}
+
+uint32_t OpticalFlowData::NbFeatures(void) const
+{
+    return nb_features;
+}
+
+void OpticalFlowData::SetNbFeatures(uint32_t value)
+{
+    GetMutex();
+    nb_features=value;
+    ReleaseMutex();
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowData.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowData.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowData.h	(revision 122)
@@ -0,0 +1,144 @@
+/*!
+ * \file OpticalFlowData.h
+ * \brief Class defining pptical flow datas
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2012/04/12
+ * \version 4.0
+ */
+
+#ifndef OPTICALFLOWDATA_H
+#define OPTICALFLOWDATA_H
+
+#include <cxcore.h>
+#include <io_data.h>
+
+namespace flair { namespace filter {
+    /*! \class OpticalFlowData
+    *
+    * \brief Class defining optical flow datas
+    *
+    * Optical flow datas are composed of the following: \n
+    * PointsA: tracked points on first image
+    * PointsB: tracked points on second image
+    * FoundFeature: array representing if a point on first image is found on second image
+    * FeatureError: array representing correlation error for each point (confidence)
+    */
+    class OpticalFlowData: public core::io_data {
+    public:
+        class Type: public core::DataType {
+            size_t GetSize() const {return 0;} //TODO
+            std::string GetDescription() const {return "optical flow";}
+        };
+
+        /*!
+        * \brief Constructor
+        *
+        * Construct OpticalFlowData.
+        *
+        * \param parent parent
+        * \param max_features maximum number of features to track
+        * \param name name
+        * \param n number of samples for the io_data
+        */
+        OpticalFlowData(const core::Object* parent,uint32_t max_features,std::string name="",uint32_t n=1);
+
+        /*!
+        * \brief Destructor
+        *
+        */
+        ~OpticalFlowData();
+
+        /*!
+        * \brief Points on first image
+        *
+    */
+        CvPoint* PointsA(void) const;
+
+        /*!
+        * \brief Points on second image
+        *
+        */
+        CvPoint2D32f* PointsB(void) const;
+
+        /*!
+        * \brief Features found
+        *
+        * value of the array is one if feature is found
+        */
+        char *FoundFeature(void) const;
+
+        /*!
+        * \brief Correlation error
+        *
+        */
+        uint32_t *FeatureError(void) const;
+
+        /*!
+        * \brief Set points of interest of frst image
+        *
+        * \param points points
+        */
+        void SetPointsA(const CvPoint *points);
+
+        /*!
+        * \brief Set points of interest of second image
+        *
+        * \param points points
+        */
+        void SetPointsB(const CvPoint2D32f *points);
+
+        /*!
+        * \brief Set found features
+        *
+        * \param found_features found features
+        */
+        void SetFoundFeature(const char *found_features);
+
+        /*!
+        * \brief Set features error
+        *
+        * \param features_error features error
+        */
+        void SetFeatureError(const unsigned int *features_error);
+
+        /*!
+        * \brief Number of maximum features
+        *
+        */
+        uint32_t MaxFeatures(void) const;
+
+        /*!
+        * \brief Number of tracked features
+        *
+        */
+        uint32_t NbFeatures(void) const;
+
+        /*!
+        * \brief Set number of tracked features
+        *
+        * \param value number of tracked features
+        */
+        void SetNbFeatures(uint32_t value);
+
+        /*!
+        * \brief Change number of maximum features
+        *
+        * \param value new number of maximum tracked features
+        */
+        void Resize(uint32_t value);
+
+        OpticalFlowData::Type const &GetDataType() const {return dataType;}
+
+    private:
+        uint32_t max_features;
+        uint32_t nb_features;
+        CvPoint* pointsA;
+        CvPoint2D32f* pointsB;
+        char *found_features;
+        uint32_t *features_error;
+        void CopyDatas(char* dst) const;
+        Type dataType;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // OPTICALFLOWDATA_H
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.cpp	(revision 122)
@@ -0,0 +1,87 @@
+//  created:    2012/04/12
+//  filename:   OpticalFlowSpeed.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    calcul de la vitesse à partir du flux optique
+//
+//
+/*********************************************************************/
+
+#include "OpticalFlowSpeed.h"
+#include "OpticalFlowData.h"
+#include <cvmatrix.h>
+#include <Object.h>
+
+using std::string;
+using namespace flair::core;
+
+namespace flair
+{
+namespace filter
+{
+
+OpticalFlowSpeed::OpticalFlowSpeed(const IODevice* parent,string name) : IODevice(parent,name)
+{
+    cvmatrix_descriptor* desc=new cvmatrix_descriptor(2,1);
+    desc->SetElementName(0,0,"vx");
+	desc->SetElementName(1,0,"vy");
+    output=new cvmatrix(this,desc,floatType,name);
+
+	AddDataToLog(output);
+}
+
+OpticalFlowSpeed::~OpticalFlowSpeed(void)
+{
+}
+
+void OpticalFlowSpeed::UpdateFrom(const io_data *data)
+{
+    OpticalFlowData *input=(OpticalFlowData*)data;
+    float deplx,deply;
+    int nb_depl=0;
+
+    deplx=0;
+    deply=0;
+
+    input->GetMutex();
+    for(int i=0;i<input->NbFeatures();i++)
+    {
+        if(input->FoundFeature()[i]!=0)
+        {
+            deplx+=input->PointsB()[i].x-input->PointsA()[i].x;
+            deply+=input->PointsB()[i].y-input->PointsA()[i].y;
+            nb_depl++;
+        }
+    }
+    input->ReleaseMutex();
+
+    if(nb_depl!=0)
+    {
+        output->SetValue(0,0,deplx/nb_depl);
+        output->SetValue(1,0,deply/nb_depl);
+    }
+
+    output->SetDataTime(data->DataTime());
+    ProcessUpdate(output);
+}
+
+float OpticalFlowSpeed::Vx(void) const
+{
+    return output->Value(0,0);
+}
+
+float OpticalFlowSpeed::Vy(void) const
+{
+    return output->Value(1,0);
+}
+
+core::cvmatrix *OpticalFlowSpeed::Output() const
+{
+    return output;
+}
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/OpticalFlowSpeed.h	(revision 122)
@@ -0,0 +1,89 @@
+/*!
+ * \file OpticalFlowSpeed.h
+ * \brief Optical flow speed calculation
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2012/04/12
+ * \version 4.0
+ */
+
+
+#ifndef OPTICALFLOWSPEED_H
+#define OPTICALFLOWSPEED_H
+
+#include <IODevice.h>
+
+namespace flair
+{
+    namespace core
+    {
+        class cvmatrix;
+    }
+}
+
+namespace flair
+{
+namespace filter
+{
+    class OpticalFlow;
+
+    /*! \class OpticalFlowSpeed
+    *
+    * \brief Optical flow speed calculation
+    *
+    * Speed is the mean of all optical flow values.
+    */
+    class OpticalFlowSpeed : public core::IODevice
+    {
+        public:
+            /*!
+            * \brief Constructor
+            *
+            * Construct OpticalFlowSpeed.
+            *
+            * \param parent parent
+            * \param name name
+            */
+            OpticalFlowSpeed(const core::IODevice* parent,std::string name);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~OpticalFlowSpeed();
+
+            /*!
+            * \brief Speed along x axis
+            *
+            */
+            float Vx(void) const;
+
+            /*!
+            * \brief Speed along y axis
+            *
+            */
+            float Vy(void) const;
+
+            /*!
+            * \brief Output matrix
+            *
+            * Matrix is of sze (2,1). \n
+            * First line is speed along x axis. \n
+            * Second line is speed along y axis. \n
+            */
+            core::cvmatrix *Output() const;
+
+        private:
+            /*!
+            * \brief Update using provided datas
+            *
+            * Reimplemented from IODevice.
+            *
+            * \param data data from the parent to process
+            */
+            void UpdateFrom(const core::io_data *data);
+
+            core::cvmatrix *output;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // OPTICALFLOWSPEED_H
Index: /trunk/lib/FlairVisionFilter/src/Sobel.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/Sobel.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/Sobel.cpp	(revision 122)
@@ -0,0 +1,77 @@
+//  created:    2015/10/07
+//  filename:   Sobel.cpp
+//
+//  author:     Gildas Bayard
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Sobel
+//
+//
+/*********************************************************************/
+
+#include "Sobel.h"
+#include <cvimage.h>
+#include <Layout.h>
+#include <GroupBox.h>
+#include <SpinBox.h>
+#include <typeinfo>
+
+using std::string;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair { namespace filter {
+
+Sobel::Sobel(const IODevice* parent,const LayoutPosition* position,string name) : IODevice(parent,name),output(0) {
+    GroupBox* reglages_groupbox=new GroupBox(position,name);
+    dx=new SpinBox(reglages_groupbox->NewRow(),"dx:",0,1,1,1);
+    dy=new SpinBox(reglages_groupbox->NewRow(),"dy:",0,1,1,1);
+
+    Printf("TODO: IODevice doit faire un check de GetInputDataType et GetOutputDataType\n");
+    //cvimage devrait accepter un type dans son constructeur pour construire un type identique
+    try{
+        cvimage::Type const &imageType=dynamic_cast<cvimage::Type const &>(parent->GetOutputDataType());
+        if(imageType.GetFormat()==cvimage::Type::Format::GRAY) {
+            output=new cvimage(this,imageType.GetWidth(),imageType.GetHeight(),imageType.GetFormat(),"sobel");
+        } else {
+            Err("input image is not grey\n");
+        }
+
+    } catch(std::bad_cast& bc) {
+        Err("io type mismatch\n");
+    }
+}
+
+Sobel::~Sobel(void) {
+}
+
+cvimage* Sobel::Output(void) {
+    return output;
+}
+
+void Sobel::UpdateFrom(const io_data *data) {
+    cvimage *cvImage=(cvimage*)data;
+    IplImage *gimg=cvImage->img;
+/*
+    data->GetMutex();
+    output->GetMutex();
+    dspSobel(gimg,output->img,dx->Value(),dy->Value());
+    output->ReleaseMutex();
+    data->ReleaseMutex();
+*/
+    output->SetDataTime(data->DataTime());
+    ProcessUpdate(output);
+}
+
+DataType const &Sobel::GetOutputDataType() const {
+    if(output!=NULL) {
+        return output->GetDataType();
+    } else {
+        return dummyType;
+    }
+}
+
+} // end namespace filter
+} // end namespace flair
Index: /trunk/lib/FlairVisionFilter/src/Sobel.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/Sobel.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/Sobel.h	(revision 122)
@@ -0,0 +1,72 @@
+/*!
+ * \file Sobel.h
+ * \brief Sobel algorithm
+ * \author Gildas Bayard, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2015/10/07
+ * \version 4.0
+ */
+
+
+#ifndef SOBEL_H
+#define SOBEL_H
+
+#include <IODevice.h>
+#include <cv.h>
+
+namespace flair {
+    namespace core {
+        class cvimage;
+    }
+    namespace gui {
+        class LayoutPosition;
+        class SpinBox;
+    }
+}
+
+namespace flair { namespace filter {
+    /*! \class Sobel
+    *
+    * \brief Sobel algorithm
+    *
+    * Sobel is done using the DSP of the DM3730.
+    */
+    class Sobel : public core::IODevice {
+        public:
+            /*!
+            * \brief Constructor
+            *
+            * Construct an OpticalFlow filter at given position. \n
+            * After calling this function, position will be deleted as it is no longer usefull. \n
+            *
+            * \param parent parent
+            * \param position position
+            * \param name name
+            */
+            Sobel(const core::IODevice* parent,const gui::LayoutPosition* position,std::string name);
+
+            /*!
+            * \brief Destructor
+            *
+            */
+            ~Sobel();
+
+            /*!
+            * \brief Output image
+            *
+            * Output matrix is of the same size as the input image. \n
+            *
+            * \return the output image
+            */
+            core::cvimage* Output(void);
+
+            core::DataType const &GetOutputDataType() const;
+
+        private:
+            void UpdateFrom(const core::io_data *data);
+            core::cvimage *output;
+            gui::SpinBox *dx;
+            gui::SpinBox *dy;
+    };
+} // end namespace filter
+} // end namespace flair
+#endif // SOBEL_H
Index: /trunk/lib/FlairVisionFilter/src/init.cpp
===================================================================
--- /trunk/lib/FlairVisionFilter/src/init.cpp	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/init.cpp	(revision 122)
@@ -0,0 +1,10 @@
+#include "init.h"
+
+
+void SetupDSP(std::string file,int globalTimeoutMs) {
+    
+}
+
+void CloseDSP(void) {
+  
+}
Index: /trunk/lib/FlairVisionFilter/src/init.h
===================================================================
--- /trunk/lib/FlairVisionFilter/src/init.h	(revision 122)
+++ /trunk/lib/FlairVisionFilter/src/init.h	(revision 122)
@@ -0,0 +1,16 @@
+#include <string>
+
+/*!
+* \brief DSP setup
+*
+* Setup DSP executable file. \n
+* If this method is not called, no DSP processing will be available. \n
+*
+* \param file DSP executable file
+* \param globalTimeoutMs timeout for all DSP functions, in ms (timeout is only
+* used to display a warning. -1 to disable timeout
+*/
+void SetupDSP(std::string file,int globalTimeoutMs=-1);
+
+
+void CloseDSP(void);
